with sr;
use sr;

package club
with SPARK_Mode
is

   subtype CRStype is Integer range 1 .. 30;

   CRScs : set (CRStype) := (others => True);

   function cs return Boolean is
     (isFullSet (CRScs)) with
       Global => (CRScs),
     Depends => (cs'Result => (CRScs));

   m : constant Boolean := False;

   function Axm1 return Boolean is
     (m = False) with
     Global => (m),
     Depends => (Axm1'Result => (m));

   crs : set (CRStype);

   function Inv1 return Boolean is
     (inPowerSet (crs,CRScs)) with
     Global => (crs,CRScs),
     Depends => (Inv1'Result => (crs,CRScs));

   procedure INITIALISATION with
     Pre => (cs and then Axm1),
     Post => (cs and then Axm1 and then Inv1 and then
              isEmpty (crs)),
     Global => (Proof_In => (CRScs,m),
                Output => (crs)),
     Depends => (crs => null);

   procedure OpenCourses (cs : in set (CRStype)) with
     Pre => (cs and then Axm1 and then Inv1 and then
             isSubset (cs,CRScs) and then
             intersectionEmpty (crs,cs) and then
             not (isEmpty (cs))),
     Post => (cs and then Axm1 and then Inv1 and then
              equalsUnion (crs,crs'Old,cs)),
     Global => (Proof_In => (CRScs,m),
                In_Out => (crs)),
     Depends => (crs =>+ (cs));

   procedure CloseCourses (cs : in set (CRStype)) with
     Pre => (cs and then Axm1 and then Inv1 and then
             isSubset (cs,crs) and then
             not (isEmpty (cs))),
     Post => (cs and then Axm1 and then Inv1 and then
              equalsDifference (crs,crs'Old,cs)),
     Global => (Proof_In => (CRScs,m),
                In_Out => (crs)),
     Depends => (crs =>+ (cs));

end club;
